:- [initialisierung],[io],[gui],[ki],[start_gui_client].

init :-
	retractall(spielfeld(_)),
	free(@haupt),
	free(@icon),
        new(@haupt, dialog('Carolus Magnus')),
	send(@haupt, size, size(800,600)),
	send(@haupt, can_resize, @off),
	send(@haupt, background, lightyellow),
	send(@haupt, confirm_done, @on),
	menu(@haupt),
	groups(@haupt),
	send(@haupt, open_centered).

menu(F) :-
	send(F, append, new(MB, menu_bar)),
	send(MB, append, new(Spiel, popup('Spiel'))),
	free(@mins),
	free(@miss),
	free(@misl),
	free(@miins),
	free(@misv),
	free(@mib),
	free(@midsb),
	send_list(Spiel, append,
		  [new(@mins, menu_item('Neues Spiel',
			     message(@prolog, neues_spiel_dialog))),
		   new(@miss, menu_item('Spiel Speichern',
			     message(@prolog, speichern))),
		   new(@misl, menu_item('Spiel Laden',
			     message(@prolog, lade_dialog))),
		   new(@miins, menu_item('Im Netzwerk spielen',
			     message(@prolog, client_dialog))),
		   new(@misv, menu_item('Server verlassen',
			     message(@prolog, server_verlassen))),
		   new(@midsb, menu_item('Dieses Spiel beenden',
			     message(@prolog, reset_fenster))),
		   new(@mib, menu_item('"Carolus Magnus" beenden',
			     message(@prolog, beenden)))]),
	send(@misv,active,@off),
	send(@midsb,active,@off),
	send(@miss,active,@off),
	send(MB, append, new(Einstellungen, popup('Einstellungen'))),
	free(@aufl1),
	free(@aufl2),
	free(@aufl3),
	free(@aufl4),
	free(@bots),
	send_list(Einstellungen, append,
		  [new(@aufl1,menu_item('Aufloesung: 800x600',
					message(@prolog, setze_aufloesung,800,600))),
		   new(@aufl2,menu_item('Aufloesung: 1024x768',
					message(@prolog, setze_aufloesung,1024,768))),
		   new(@aufl3,menu_item('Aufloesung: 1280x720',
					message(@prolog, setze_aufloesung,1280,720))),
		   new(@aufl4,menu_item('Aufloesung: 1280x960',
					message(@prolog, setze_aufloesung,1280,960))),
		   new(@bots,menu_item('Setze Bots',
				       message(@prolog, bot_dialog)))]),
	send(@aufl1,active,@off),
	send(@aufl2,active,@off),
        send(@aufl3,active,@off),
        send(@aufl4,active,@off),
	send(@bots,active,@off),
	send(MB, append, new(Hilfe, popup('Hilfe'))),
	send_list(Hilfe, append,
		  [menu_item('Spielregeln',
			     message(@prolog,rules_dialog)),
		   menu_item('Impressum',
			     message(@prolog,impressum_dialog)),
		   menu_item('Ueber Uns',
			     message(@prolog,about_dialog))]).

neues_spiel_dialog :-
	new(Dialog, dialog('Neues Spiel erstellen')),
	send_list(Dialog, append, [new(D1, device),
				   new(D2, device),
				   new(D3, device),
				   new(D4, device)
				  ]),
	send(D1, display, new(Name1, text_item('Rot', 'Spieler1'))),
	send(D2, display, new(Name2, text_item('Blau', 'Spieler2'))),
	send(D3, display, new(Name3, text_item('Gruen', 'Spieler3'))),
	new(Check1, menu('Bot')),
	send(Check1, multiple_selection, true),
	send_list(Check1, append, [rot,blau,gruen]),
	send(D4, display, Check1),
	send(Dialog, append,
	     button('Starten', and(message(@prolog,
					 neues_spiel,Name1,Name2,Name3,
					 Check1?selection),
				   message(Dialog, destroy)))),
	send(Dialog, append,
	     button('Abbrechen', message(Dialog, destroy))),
	send(Dialog, default_button, 'Starten'),
	send(Dialog, transient_for, @haupt),
	send(Dialog, modal, transient),
	send(Dialog, open_centered).

neues_spiel(_,_,_,Check1) :-
	chain_list(Check1,CheckList),
	length(CheckList,3),
	new(Dialog, dialog('Fehler')),
	send(Dialog, append, text('Wirklich? 3 Bots?')),
	send(Dialog, append, button('Abbrechen', message(Dialog, destroy))),
	send(Dialog, default_button, 'Abbrechen'),
	send(Dialog, transient_for, @haupt),
	send(Dialog, modal, transient),
	send(Dialog, open_centered).

neues_spiel(Name1,Name2,Name3,Check1) :-
	chain_list(Check1,CheckList),
	length(CheckList,X),
	X < 3,
	MaxL = 10,
	get(Name1,value,RName1),
	(string_length(RName1,L1),L1>MaxL->
	 sub_string(RName1,0,MaxL,_,Neu1);
	 RName1 = Neu1),
	get(Name2,value,RName2),
	(string_length(RName2,L2),L2>MaxL->
	 sub_string(RName2,0,MaxL,_,Neu2);
	 RName2 = Neu2),
        get(Name3,value,RName3),
	(string_length(RName3,L3),L3>MaxL->
	 sub_string(RName3,0,MaxL,_,Neu3);
	 RName3 = Neu3),
	setze_einzel_akt,
	starte_spielfeld([Neu1,Neu2,Neu3],CheckList),
	setze_window.

setze_aufloesung(X,Y) :-
	X1 is X - 220,
	Y1 is Y - 60,
	send(@haupt,width,X),
	send(@haupt,height,Y),
	retractall(masse_display(_,_)),
	assert(masse_display(X1,Y1)),
	(spielfeld(_)->resize_neu;true).

beenden :-
	(client_spieler(_)->
	 send(@haupt, report, error, 'Zuerst Ausloggen!');
	 free(@haupt)).

groups(F) :-
	free(@maingroup),
	new(@maingroup, dialog_group('MainGroup', group)),
	new(LG, dialog_group('Info',group)),
	spielstand(LG),
	spielphase(LG),
	chat(LG),
	send(LG, gap, size(0,30)),
	send(@maingroup, append, LG),
	free(@gui2spielfeld),
	new(@gui2spielfeld, dialog_group('Spielfeld',group)),
	spielplatz(@gui2spielfeld),
	send(@maingroup, append, @gui2spielfeld, right),
	send(@maingroup, gap, size(10,0)),
	send(F, append, @maingroup).

spielstand(F) :-
	free(@spielstand),
	free(@spielstandtext),
	send(F,append,new(@spielstand, dialog_group('Spielstand'))),
	send(@spielstand, append, new(@spielstandtext, text('\n\n\n'))),
	send(@spielstand, gap, size(5,20)).

spielphase(F) :-
	free(@spielphase),
	free(@spielphasetext),
	free(@beendeZug),
	free(@dummerBotZug),
	send(F,append,new(@spielphase, dialog_group('Spielphase'))),
	send(@spielphase, append, new(@spielphasetext, text(''))),
	new(@beendeZug,
	    button('Zug Beenden', and(message(@prolog, zug_beenden),
			              message(@prolog, aktualisiere_gui2)))),
	send(@beendeZug, active, @off),
	new(@dummerBotZug, button('Bot ziehen lassen', message(@prolog, botZug))),
	send(@spielphase, append, @beendeZug),
	send(@spielphase, append, @dummerBotZug, next_row),
	send(@dummerBotZug, active, @off),
	send(@spielphase, gap, size(5,10)).

botZug :-
	retractall(clipboard(_)),
	dummerBotZug,
	aktualisiere_gui2.

chat(F) :-
	free(@chat),
	send(F, append,new(@chat, dialog_group('Chat'))),
	free(@chatarea),
	send(@chat, append, new(@chatarea, editor)),
	send(@chatarea, size, size(16,10)),
	send(@chatarea, background, colour(black)),
	send(@chatarea, colour, colour(white)),
	send(@chatarea, editable, @off),
	free(@chateingabe),
	send(@chat, append, new(@chateingabe, editor),next_row),
	send(@chateingabe, size, size(16,1)),
	send(@chateingabe, editable, @on),
	send(@chateingabe, key_binding, 'RET', message(@prolog,send_message)),
	send(@chat, gap, size(5,20)),
	send(@chat, active, @off).

spielplatz(F) :-
	free(@fenster),
	new(@fenster, picture('',size(580,540))),
	send(F, append, @fenster).

aktualisiere_gui2 :-
	not(spielfeld(_)),
	aktualisiere_spielstand,
	aktualisiere_spielphase,
	aktualisiere_buttons.

aktualisiere_gui2 :-
	spielfeld(_),
	(gewinner([Spieler]) ->
	 zeige_gewinnertext(Spieler); true),
	aktualisiere_gui,
	aktualisiere_spielstand,
	aktualisiere_spielphase,
	aktualisiere_buttons,
	(client_spieler(Spieler),
	 aktueller_spieler(Spieler),
	 (phase(3);bietphase(_))->
	 send(@haupt, bell, 100);true).

zeige_gewinnertext(Spieler) :-
	new(Dialog, dialog('Game Over!')),
	atomic_list_concat(['Spieler ',Spieler,' hat gewonnen!'], Gewinnertext),
	send(Dialog, append, text(Gewinnertext)),
	send(Dialog, append, button(beenden, message(Dialog, destroy))),
	send(Dialog, default_button, beenden),
	send(Dialog, bell, 100),
	send(Dialog, transient_for, @haupt),
	send(Dialog, modal, transient),
	send(Dialog, can_delete, @off),
	send(Dialog, open_centered).

aktualisiere_spielstand :-
	spielfeld(_),
	findall(-(EB,Name+Farbe),
		(spieler(Name,Farbe,Burgenanzahl), EB is 8-Burgenanzahl),
		Liste),
	keysort(Liste, SListe),
	spielerStand(SListe,String),
	send(@spielstandtext, string, String).

aktualisiere_spielstand :-
	not(spielfeld(_)),
	send(@spielstandtext, string, '').

spielerStand([],'').
spielerStand([-(Burgenanzahl,Name+Farbe)|Rest],RString) :-
	spielerStand(Rest,String),
	atomic_list_concat([String,
			    Name,
			    ' (',
			    Farbe,
			    '): ',
			    Burgenanzahl, '/8\n'],
			   RString).

aktualisiere_spielphase :-
	phase(X),
	phasen(X,Phase),
	ziehphase([Spieler|_]),
	spieler(Name,Spieler,_),
	atomic_list_concat([Phase, ': ', Name],Text),
	send(@spielphasetext, string, Text).

aktualisiere_spielphase :-
	not(phase(_)),
	bietphase([Spieler|_]),
	spieler(Name,Spieler,_),
	atomic_list_concat(['Bieten: ',Name],Text),
	send(@spielphasetext, string, Text).

aktualisiere_spielphase :-
	not(phase(_)),
	not(bietphase(_)),
	send(@spielphasetext, string, 'Spielende').

aktualisiere_spielphase :-
	not(spielfeld(_)),
	send(@spielphasetext, string, '').

aktualisiere_buttons :-
       (not(client_spieler(_)),phase(-1)->
        send(@beendeZug, active, @on);
	send(@beendeZug, active, @off)),
       (client_spieler(Farbe) ->
	send(@mins, active, @off),
	send(@miss, active, @off),
	send(@misl, active, @off),
	send(@miins, active, @off),
	send(@misv, active, @on),
	send(@chat, active, @on),
	atomic_list_concat(['Carolus Magnus - ',Farbe],Label),
	send(@haupt, label, Label),
	send(@haupt, can_delete, @off);
	send(@mins, active, @on),
	send(@miss, active, @on),
	send(@misl, active, @on),
	send(@miins, active, @on),
	send(@misv, active, @off),
        send(@chat, active, @off),
        send(@haupt, label, 'Carolus Magnus'),
        send(@haupt, can_delete, @on)),
       (spielfeld(_)->
        send(@aufl1,active,@on),
	send(@aufl2,active,@on),
	send(@aufl3,active,@on),
	send(@aufl4,active,@on),
	send(@miss,active,@on),
	send(@dummerBotZug,active,@on);
        send(@aufl1,active,@off),
        send(@aufl2,active,@off),
	send(@aufl3,active,@off),
        send(@aufl4,active,@off),
	send(@miss,active,@off),
        send(@dummerBotZug,active,@off)),
       (spielfeld(_),not(client_spieler(_)) ->
	send(@midsb,active,@on),
	send(@bots,active,@on);
	send(@midsb,active,@off)).

send_message :-
	client_spieler(Spieler),
	spieler(Name,Spieler,_),
	get(@chateingabe, first_line,X),
	get(X,value,String),
	atom_concat(Name,': ',Nam),
	atom_concat(Nam,String,Nachricht),
	sende(nachricht(Nachricht)),
	send(@chateingabe, clear).

schreibe(Text) :-
	send(@chatarea, append, Text),
	send(@chatarea, append, '\n').

rules_dialog :-
	free(@rules_editor),
	new(Dialog, dialog('Spielregeln')),
	       send_list(Dialog, append,
		  [
		   new(@rules_editor, editor),
		   button(ok,message(Dialog,destroy))
		  ]),
	send(@rules_editor, load, 'text/spielregeln.txt'),
	send(@rules_editor, wrap, word),
	send(@rules_editor, editable, @off),
	send(Dialog, default_button, ok),
	send(Dialog, transient_for, @haupt),
	send(Dialog, modal, transient),
	send(Dialog, open_centered).

about_dialog :-
	free(@about_editor),
	new(Dialog, dialog('Ueber Uns')),
	       send_list(Dialog, append,
		  [
		   new(@about_editor, editor),
		   button(ok,message(Dialog,destroy))
		  ]),
	send(@about_editor, load, 'text/about.txt'),
	send(@about_editor, wrap, word),
	send(@about_editor, editable, @off),
	send(Dialog, default_button, ok),
	send(Dialog, transient_for, @haupt),
	send(Dialog, modal, transient),
	send(Dialog, open_centered).

impressum_dialog :-
	free(@impressum),
	new(Dialog, dialog('Impressum')),
	       send_list(Dialog, append,
		  [
		   new(@impressum, text('Hier der Link')),
		   button(ok,message(Dialog,destroy))
		  ]),
	send(Dialog, default_button, ok),
	send(Dialog, transient_for, @haupt),
	send(Dialog, modal, transient),
	send(Dialog, open_centered).

lade_dialog :- new(Dialog, dialog('Laden')),
	       send_list(Dialog, append,
		  [
		   new(Datei, menu(dateien, cycle)),
		   button(cancel, message(Dialog,
					  destroy)),
		   button(enter, and(message(@prolog,
					     laden_und_anzeigen, Datei?selection),
				     message(Dialog,destroy)))
		  ]),
	directory_files('save/',[_,_|Liste]),
	send_list(Datei, append, Liste),
	send(Dialog, default_button, enter),
	send(Dialog, transient_for, @haupt),
	send(Dialog, modal, transient),
	send(Dialog, open_centered).

laden_und_anzeigen(LadeDatei) :-
	free_felderinhalt(15),
	laden(LadeDatei),
	setze_einzel_akt,
        setze_window.

client_dialog :-
	new(Dialog, dialog('Verbinden')),
	send_list(Dialog, append,
		  [
		   new(Host, text_item(host, 'localhost')),
		   new(Port, text_item(port, '4444')),
		   button(cancel, message(Dialog, destroy)),
		   button(enter, and(message(@prolog,
					     gui_client_start, Host, Port),
				     message(Dialog,
					     destroy)))
		  ]),
	send(Dialog, default_button, enter),
	send(Dialog, transient_for, @haupt),
	send(Dialog, modal, transient),
	send(Dialog, open_centered).

gui_client_start(Host,Port) :-
	get(Host,value,HostV),
	get(Port,value,PortV),
	start_client(HostV,PortV).

setze_window :-
	masse_display(X,Y),
	erzeuge_window(X,Y),
	send(@gui2spielfeld, append, @fenster),
	setze_aufloesung(800,600),
	aktualisiere_gui2.

anmeldung_dialog(Liste) :-
	new(Dialog, dialog('Hier Titel')),
	send(Dialog, append, new(Name, text_item('Name', 'Spieler'))),
	new(M, menu('Farbe')),
	append(Liste,[gast],GListe),
	send_list(M, append, GListe),
	send(M, layout, vertical),
	send(Dialog, append , M),
	send(Dialog, append,
	     button('Anmelden', and(message(@prolog, anmeldung_abschicken,
					    Name,M?selection),
				    message(Dialog, destroy)))),
	send(Dialog, append,
	     button('Abbrechen', and(message(@prolog, server_verlassen),
				     message(Dialog, destroy)))),
	send(Dialog, can_delete, @off),
	send(Dialog, can_resize, @off),
	send(Dialog, default_button, 'Anmelden'),
	send(Dialog, transient_for, @haupt),
	send(Dialog, modal, transient),
	send(Dialog, open_centered).

anmeldung_abschicken(Name,Farbe) :-
	get(Name, value, NameN),
	MaxL = 10,
	(string_length(NameN,L1),L1>MaxL->
	 sub_string(NameN,0,MaxL,_,Neu1);
	 NameN = Neu1),
	sende(anmeldung(Neu1,Farbe)).

server_verlassen :-
	ende,
	reset_fenster.

reset_fenster :-
	retractall(bot(_)),
	retractall(spielfeld(_)),
	spielplatz(@gui2spielfeld),
	aktualisiere_gui2.

bot_dialog :-
	new(Dialog, dialog('Setze Bots')),
	new(M, menu('Farbe')),
	send(M, append, 'rot'),
	send(M, append, 'blau'),
	send(M, append, 'gruen'),
	send(M, layout, vertical),
	send(M, multiple_selection, @on),
	findall(Farbe,bot(Farbe),Farben),
	chain_list(Chain,Farben),
	forall(bot(Farbe),send(M, selection, Chain)),
	send(Dialog, append , M),
	send(Dialog, append,
	     button('Setze Bots', and(message(@prolog, setze_bots,M?selection),
				      message(Dialog, destroy)))),
	send(Dialog, append,
	     button('Abbrechen', message(Dialog, destroy))),
	send(Dialog, can_delete, @off),
	send(Dialog, can_resize, @off),
	send(Dialog, default_button, 'Setze Bots'),
	send(Dialog, transient_for, @haupt),
	send(Dialog, modal, transient),
	send(Dialog, open_centered).

setze_bots(Chain) :-
	retractall(bot(_)),
	chain_list(Chain,Liste),
	forall(member(Farbe,Liste),assert(bot(Farbe))),
	ueberpruefe_bot.

:- init.
