:- [bieten],[ziehen],[util],[io].


:- dynamic spielfeld/1, bot/1.

starte_spielfeld(X) :-
	integer(X),
	retractall(spielfeld(_)),
	spielfeld_initialisieren([spieler1,spieler2,spieler3],
				 [rot,blau,gruen],SpielfeldA),
	starte_bietphase(SpielfeldA,SpielfeldB),
	assert(spielfeld(SpielfeldB)).

starte_spielfeld(Liste) :-
	starte_spielfeld(Liste,[]).

starte_spielfeld(Liste,Bots) :-
	retractall(spielfeld(_)),
	retractall(bot(_)),
	spielfeld_initialisieren(Liste,[rot,blau,gruen],SpielfeldA),
	forall(member(Farbe,Bots),assert(bot(Farbe))),
	starte_bietphase(SpielfeldA,SpielfeldB),
	assert(spielfeld(SpielfeldB)),
	ueberpruefe_bot.

% spielfeld_initialisieren(?AnzahlSpieler)
% Setzt den Datenbankzustand zum Start
spielfeld_initialisieren(Spieler,Farben,Spielfeld) :-
   fuege_spieler_hinzu3(Spieler,Farben,[zugreihenfolge([rot,blau,gruen])],SpielfeldmitSpieler),
   random(1,16,FID),
   append(SpielfeldmitSpieler,[kaiser(FID),
			   feld(1,15,2),
			   feld(2,1,3),
			   feld(3,2,4),
			   feld(4,3,5),
			   feld(5,4,6),
			   feld(6,5,7),
			   feld(7,6,8),
			   feld(8,7,9),
			   feld(9,8,10),
			   feld(10,9,11),
			   feld(11,10,12),
			   feld(12,11,13),
			   feld(13,12,14),
			   feld(14,13,15),
			   feld(15,14,1)],SpielfeldFeld),
   append(SpielfeldFeld,[ritter_auf_feld(1,0,0,0,0,0),
			 ritter_auf_feld(2,0,0,0,0,0),
			 ritter_auf_feld(3,0,0,0,0,0),
			 ritter_auf_feld(4,0,0,0,0,0),
			 ritter_auf_feld(5,0,0,0,0,0),
			 ritter_auf_feld(6,0,0,0,0,0),
			 ritter_auf_feld(7,0,0,0,0,0),
			 ritter_auf_feld(8,0,0,0,0,0),
			 ritter_auf_feld(9,0,0,0,0,0),
			 ritter_auf_feld(10,0,0,0,0,0),
			 ritter_auf_feld(11,0,0,0,0,0),
			 ritter_auf_feld(12,0,0,0,0,0),
			 ritter_auf_feld(13,0,0,0,0,0),
			 ritter_auf_feld(14,0,0,0,0,0),
			 ritter_auf_feld(15,0,0,0,0,0)],Spielfeld).

/*
spielfeld_initialisieren(2,Spielfeld) :-
   fuege_spieler_hinzu(2,2,[zugreihenfolge([rot,blau])],SpielfeldmitSpieler),
   random(1,16,FID),
   append(SpielfeldmitSpieler,[kaiser(FID),feld(1,15,2),
			   feld(2,1,3),
			   feld(3,2,4),
			   feld(4,3,5),
			   feld(5,4,6),
			   feld(6,5,7),
			   feld(7,6,8),
			   feld(8,7,9),
			   feld(9,8,10),
			   feld(10,9,11),
			   feld(11,10,12),
			   feld(12,11,13),
			   feld(13,12,14),
			   feld(14,13,15),
			   feld(15,14,1)],SpielfeldFeld),
   append(SpielfeldFeld,[ritter_auf_feld(1,0,0,0,0,0),
			 ritter_auf_feld(2,0,0,0,0,0),
			 ritter_auf_feld(3,0,0,0,0,0),
			 ritter_auf_feld(4,0,0,0,0,0),
			 ritter_auf_feld(5,0,0,0,0,0),
			 ritter_auf_feld(6,0,0,0,0,0),
			 ritter_auf_feld(7,0,0,0,0,0),
			 ritter_auf_feld(8,0,0,0,0,0),
			 ritter_auf_feld(9,0,0,0,0,0),
			 ritter_auf_feld(10,0,0,0,0,0),
			 ritter_auf_feld(11,0,0,0,0,0),
			 ritter_auf_feld(12,0,0,0,0,0),
			 ritter_auf_feld(13,0,0,0,0,0),
			 ritter_auf_feld(14,0,0,0,0,0),
			 ritter_auf_feld(15,0,0,0,0,0)],Spielfeld).
*/


% fuege_spieler_hinzu(+AktuellSpielerID, +AnzahlSpieler)
% Setzt die Spieler zum Datenbankstart
% AktuellSpielerID ist die ID des aktuell hinzuzufügenden Spielers
% AnzahlSpieler ist die Anzahl der Spieler im Spiel
fuege_spieler_hinzu3([],[], Spielfeld,Spielfeld).
fuege_spieler_hinzu3([SpielerName|R],[Farbe|S],SpielfeldAnfang,Spielfeld) :-
   append([spieler(SpielerName,Farbe,8),
	   ritter_gesetzt(Farbe,0,0,0,0,0),
	   reserve_ritter(Farbe,0,0,0,0,0)
	  ],SpielfeldAnfang,SpielfeldAnfang4),
  ritter_nachziehen(Farbe,9,SpielfeldAnfang4,SpielfeldAnfang5),
   reset_chips(Farbe,SpielfeldAnfang5,SpielfeldAnfang6),
   fuege_spieler_hinzu3(R, S,SpielfeldAnfang6,Spielfeld).

/*
fuege_spieler_hinzu2([],[], Spielfeld,Spielfeld).
fuege_spieler_hinzu2([SpielerName|R],[Farbe|S],SpielfeldAnfang,Spielfeld) :-
   append([spieler(SpielerName,Farbe,8),
	   ritter_gesetzt(Farbe,0,0,0,0,0),
	   reserve_ritter(Farbe,0,0,0,0,0)
	  ],SpielfeldAnfang,SpielfeldAnfang4),
  ritter_nachziehen(Farbe,7,SpielfeldAnfang4,SpielfeldAnfang5),
   reset_chips(Farbe,SpielfeldAnfang5,SpielfeldAnfang6),
   fuege_spieler_hinzu(R, S,SpielfeldAnfang6,Spielfeld).
*/

% reset_chips(+SpielerID)
% Setzt alle Chips zurueck (auf 1 bis 5)
reset_chips(ID,SpielfeldAnfang,Spielfeld) :-
   non_unifying_delete(SpielfeldAnfang,
		       noch_vorhandener_chip(ID,_),
		       SpielfeldAnfang2),
   append([noch_vorhandener_chip(ID,1),
	   noch_vorhandener_chip(ID,2),
	   noch_vorhandener_chip(ID,3),
	   noch_vorhandener_chip(ID,4),
	   noch_vorhandener_chip(ID,5)],
	  SpielfeldAnfang2,Spielfeld).
