start_client(Server,Port):-
	free(@socket),
	new(@socket, socket(tuple(Server, Port))),
	send(@socket, connect),
	send(@socket, input_message,
	     message(@prolog, message_input, @receiver, @arg1)).

sende(Nachricht) :-
	term_to_atom(Nachricht,Atom),
	atom_concat(Atom,'\n',Send),
	send(@socket, format, Send).

ende :- send(@socket,format,'schluss\n'),
	retractall(client_spieler(_)),
	send(@socket, close),
	free(@socket).

message_input(@socket,Data) :-
	get(Data,value,Value),
	writeln(Value),
	(update_feld(Value);true),
	writeln('OK').

update_feld(Value) :-
	atom_concat(Val,'\n',Value),
	atom_concat('$verb$',Lis,Val),
	atomic_list_concat(Liste,'$',Lis),
	anmeldung_dialog(Liste).

update_feld(Value) :-
	atom_concat('$start$',StartRest,Value),
        atom_concat(Spieler,UpFeld,StartRest),
	atom_concat('$up$',Spielfeld,UpFeld),
	retractall(bot(_)),
	update_spielfeld(Spielfeld),
	assert(client_spieler(Spieler)),
	(spieler = gast -> setze_gast_akt;
	spieler \= gast -> setze_netz_akt),
	setze_window.

update_feld(Value) :-
	atom_concat(Term,'\n',Value),
	not(atom_concat('$up$',_,Value)),
	term_to_atom(nachricht(String),Term),
	schreibe(String).

update_feld(Value) :-
	atom_concat('$fail$',Fale,Value),
        free(@fail),
	new(@fail,text(Fale)),
	send(@fenster, display, @fail, point(20,35)),
	writeln(Fale).

update_feld(Value) :-
	atom_concat('$go$',Spielzug,Value),
	free(@fail),
	free(@spielzug),
	new(@spielzug,text(Spielzug)),
	send(@fenster, display, @spielzug, point(20,20)),
	writeln(Spielzug).

update_feld(Value) :-
	atom_concat('$up$',Spielfeld,Value),
	update_spielfeld(Spielfeld),
	aktualisiere_gui2.

update_feld(Value) :-
	not(atom_concat('$up$',_,Value)),
	not(atom_concat('$go$',_,Value)),
	not(atom_concat('$fale$',_,Value)),
	not(atom_concat('$start$',_,Value)),
	not(atom_concat('$chat$',_,Value)),
	not((atom_concat(Term,'\n',Value),
	     term_to_atom(nachricht(_),Term))),
        free(@fail),
	atom_concat('FEHLER: ',Value,Text),
	new(@fail,text(Text)),
	send(@fenster, display, @fail, point(20,35)),
	writeln('FEHLER!!!!!!!!!!!!!!'),
	writeln(Value).

update_spielfeld(Spielfeld) :-
	retractall(spielfeld(_)),
	writeln(Spielfeld),
	term_to_atom(Term,Spielfeld),
	assert(Term).

