:- [util].

starte_ziehphase :-
	spielfeld(X),
	starte_ziehphase(X,Y),
	retractall(spielfeld(X)),
	assert(spielfeld(Y)),
	ueberpruefe_bot.

starte_ziehphase(SpielfeldAnfang,Spielfeld) :-
	not(member(gewinner(_),SpielfeldAnfang)),
	non_unifying_delete(SpielfeldAnfang,phase(_),SpielfeldAnfang2),
	non_unifying_delete(SpielfeldAnfang2,ziehphase(_),SpielfeldAnfang3),
	member(zugreihenfolge(X),SpielfeldAnfang3),
	append([ziehphase(X),phase(3)],SpielfeldAnfang3,Spielfeld).

% PHASE(1 - 3)
ritter_auf_feld_legen(Farbe,FeldHof) :-
	spielfeld(X),
	ritter_auf_feld_legen(Farbe,FeldHof,X,Y),
	retractall(spielfeld(X)),
	assert(spielfeld(Y)).

ritter_auf_feld_legen(Farbe,hof,SpielfeldAnfang0,Spielfeld) :-
	select(phase(Zuege),SpielfeldAnfang0,SpielfeldAnfang),
	Zuege > 0,
	aktueller_spieler(ID,SpielfeldAnfang),
	teste_reserve(ID,Farbe,SpielfeldAnfang),
	select(ritter_gesetzt(ID,Ro,Gr,Ge,Bl,Pi),
	       SpielfeldAnfang,
	       SpielfeldAnfang2),
	farbe(Farbe,Ro1,Gr1,Ge1,Bl1,Pi1),
	Ro2 is Ro+Ro1,
	Gr2 is Gr+Gr1,
	Ge2 is Ge+Ge1,
	Bl2 is Bl+Bl1,
	Pi2 is Pi+Pi1,
	append([ritter_gesetzt(ID,Ro2,Gr2,Ge2,Bl2,Pi2)],
	       SpielfeldAnfang2,
	       SpielfeldAnfang3),
	reserve_weg(ID,Ro1,Gr1,Ge1,Bl1,Pi1,
		    SpielfeldAnfang3,SpielfeldAnfang4),
	setze_mehrheit(Farbe,ID,SpielfeldAnfang4,SpielfeldEnde),
	ZuegeN is Zuege-1,
	append([phase(ZuegeN)],SpielfeldEnde,Spielfeld).

ritter_auf_feld_legen(Farbe,Feld,SpielfeldAnfang0,Spielfeld) :-
	select(phase(Zuege),SpielfeldAnfang0,SpielfeldAnfang),
	Zuege > 0,
	aktueller_spieler(ID,SpielfeldAnfang),
	teste_reserve(ID,Farbe,SpielfeldAnfang),
	select(ritter_auf_feld(Feld,Ro,Gr,Ge,Bl,Pi),
	       SpielfeldAnfang,
	       SpielfeldAnfang2),
	farbe(Farbe,Ro1,Gr1,Ge1,Bl1,Pi1),
	Ro2 is Ro+Ro1,
	Gr2 is Gr+Gr1,
	Ge2 is Ge+Ge1,
	Bl2 is Bl+Bl1,
	Pi2 is Pi+Pi1,
	append([ritter_auf_feld(Feld,Ro2,Gr2,Ge2,Bl2,Pi2)],
	       SpielfeldAnfang2,
	       SpielfeldAnfang3),
	reserve_weg(ID,Ro1,Gr1,Ge1,Bl1,Pi1,SpielfeldAnfang3,SpielfeldEnde),
	ZuegeN is Zuege-1,
	append([phase(ZuegeN)],SpielfeldEnde,Spielfeld).

%PHASE(0)
kaiser_bewegen(Schritte) :-
	spielfeld(X),
	kaiser_bewegen(Schritte,X,Y),
	retractall(spielfeld(X)),
	assert(spielfeld(Y)).

kaiser_bewegen(Schritte,SpielfeldAnfang,Spielfeld) :-
	select(phase(0),SpielfeldAnfang,SpielfeldAnfang2),
	aktueller_spieler(Spieler,SpielfeldAnfang2),
	member(aktuelles_gebot(Spieler,Gebot),SpielfeldAnfang2),
	moeglicher_schritt(Schritte,Gebot),
	select(kaiser(Feld),SpielfeldAnfang2,SpielfeldAnfang3),
	kaiser_bew(Schritte,Feld,Ziel,SpielfeldAnfang3),
	append([kaiser(Ziel),phase(-1)],SpielfeldAnfang3,Spielfeld).

%PHASE(-1 - -3)
zug_beenden :-
	spielfeld(X),
	zug_beenden(X,Y),
	retract(spielfeld(X)),
	assert(spielfeld(Y)),
	ueberpruefe_bot.

zug_beenden(SpielfeldAnfang,Spielfeld) :-
	burgen_tausch(SpielfeldAnfang,A),
	drei_ritter_nachziehen(A,B),
	zieh_ende(B,Spielfeld).

%PHASE(-1)
% burgen_tausch, ueberprueft die Burgen auf dem Feld auf dem der Kaiser
% steht. Wird nur ausgefuehrt wenn der Kaiser bewegt wurde (zuege(-1))
burgen_tausch :-
	spielfeld(X),
	burgen_tausch(X,Y),
	retractall(spielfeld(X)),
	assert(spielfeld(Y)).

burgen_tausch(SpielfeldAnfang,Spielfeld) :-
	select(phase(-1),SpielfeldAnfang,SpielfeldAnfang2),
	member(kaiser(Feld),SpielfeldAnfang2),
	% Ueberpruefe, ob es einen Spieler
	% mit echt meisten Punkten auf dem Feld gibt
	feld_punkte(Feld,MehrheitSpieler,Punkte,SpielfeldAnfang2),
	forall((member(spieler(_,AndererSpieler,_),SpielfeldAnfang2),
		AndererSpieler \== MehrheitSpieler),
		(feld_punkte(Feld,AndererSpieler,Punkte2,SpielfeldAnfang2),
		 Punkte>Punkte2)),
	 % ja -> Aendere Burgen
	( % alte Burgen weg, neue hinsetzen
	 select(burgen(Feld,VorherigerBesitzer,Anzahl),
		SpielfeldAnfang2,
		SpielfeldAnfang3),
	 append([burgen(Feld,MehrheitSpieler,Anzahl)],
		SpielfeldAnfang3,
		SpielfeldAnfang4),
	 burgen_zu_spieler(VorherigerBesitzer,Anzahl,
			   SpielfeldAnfang4,SpielfeldEnde),
	 MinAnzahl is -Anzahl,
	 burgen_zu_spieler(MehrheitSpieler,MinAnzahl,
			   SpielfeldEnde,SpielfeldEnde2)
	 % alternativ: es gab keine Burg -> setze eine neue
	;not(member(burgen(Feld,_,_),SpielfeldAnfang2)),
	 append([burgen(Feld,MehrheitSpieler,1)],
		SpielfeldAnfang2,
		SpielfeldAnfang3),
	 burgen_zu_spieler(MehrheitSpieler,-1,
			   SpielfeldAnfang3,SpielfeldEnde2)),
	mergen(Feld,SpielfeldEnde2,SpielfeldEnde3),
	member(feld(Feld,_,Nachf),SpielfeldEnde3),
	mergen(Nachf,SpielfeldEnde3,SpielfeldEnde4),
	append([phase(-2)],SpielfeldEnde4,Spielfeld) .

burgen_tausch(SpielfeldAnfang,Spielfeld) :-
	select(phase(-1),SpielfeldAnfang,SpielfeldAnfang2),
	member(kaiser(Feld),SpielfeldAnfang2),
	forall(member(spieler(_,Spieler,_),SpielfeldAnfang2),
	       (member(spieler(_,Spieler2,_),SpielfeldAnfang2),
		Spieler \== Spieler2,
		feld_punkte(Feld,Spieler,Punkte,SpielfeldAnfang2),
		feld_punkte(Feld,Spieler2,Punkte2,SpielfeldAnfang2),
		Punkte =< Punkte2)),
	append([phase(-2)],SpielfeldAnfang2,Spielfeld).

%PHASE(-2)
%zieht 3 neue Ritter
drei_ritter_nachziehen :-
	spielfeld(X),
	drei_ritter_nachziehen(X,Y),
	retractall(spielfeld(X)),
	assert(spielfeld(Y)).

drei_ritter_nachziehen(SpielfeldAnfang,Spielfeld) :-
	select(phase(-2),SpielfeldAnfang,SpielfeldAnfang1),
	aktueller_spieler(SpielerID,SpielfeldAnfang1),
	ritter_nachziehen(SpielerID,3,SpielfeldAnfang1,SpielfeldAnfang2),
	append([phase(-3)],SpielfeldAnfang2,Spielfeld).

%PHASE(-3)
zieh_ende :-
	spielfeld(X),
	zieh_ende(X,Y),
	retractall(spielfeld(X)),
	assert(spielfeld(Y)).

zieh_ende(SpielfeldAnfang,Spielfeld) :-
	spielende(SpielfeldAnfang,Spielfeld).

zieh_ende(SpielfeldAnfang,Spielfeld) :-
	not(spielende(SpielfeldAnfang,_)),
	spieler_wechseln(SpielfeldAnfang,Spielfeld).

zieh_ende(SpielfeldAnfang,Spielfeld) :-
	not(spielende(SpielfeldAnfang,_)),
	not(spieler_wechseln(SpielfeldAnfang,_)),
	select(phase(_),SpielfeldAnfang,SpielfeldAnfang2),
	select(ziehphase(_),SpielfeldAnfang2,SpielfeldAnfang3),
	starte_bietphase(SpielfeldAnfang3,Spielfeld).

%PHASE 3-1 Hilfsfunktionen
%reserve_weg(SpielerID,Rot,Grün,Gelb,Blau,Pink)
%löscht die gegebene Anzahl der jeweiligen Farben aus der Reserve
reserve_weg(ID,Ro1,Gr1,Ge1,Bl1,Pi1, SpielfeldAnfang,Spielfeld) :-
	select(reserve_ritter(ID,Ro,Gr,Ge,Bl,Pi),
	       SpielfeldAnfang,
	       SpielfeldEnde),
	Ro2 is Ro-Ro1,
	Gr2 is Gr-Gr1,
	Ge2 is Ge-Ge1,
	Bl2 is Bl-Bl1,
	Pi2 is Pi-Pi1,
	append([reserve_ritter(ID,Ro2,Gr2,Ge2,Bl2,Pi2)],
	       SpielfeldEnde,
	       Spielfeld).

teste_reserve(SpielerID,Farbe,Spielfeld) :-
	farbe(Farbe,Ro1,Gr1,Ge1,Bl1,Pi1),
	member(reserve_ritter(SpielerID,Ro,Gr,Ge,Bl,Pi),Spielfeld),
	Anzahl is Ro1*Ro+Gr1*Gr+Ge1*Ge+Bl1*Bl+Pi1*Pi,
	Anzahl >= 1.

%überprüft die Ritter-Mehrheit
setze_mehrheit(Farbe,ID,SpielfeldAnfang,Spielfeld) :-
	not(member(mehrheit(Farbe,_),SpielfeldAnfang)),
	append([mehrheit(Farbe,ID)],SpielfeldAnfang,Spielfeld).
setze_mehrheit(Farbe,ID,Spielfeld,Spielfeld) :-
	member(mehrheit(Farbe,ID),Spielfeld).
setze_mehrheit(Farbe,ID,SpielfeldAnfang,Spielfeld) :-
	select(mehrheit(Farbe,ID2),SpielfeldAnfang,SpielfeldAnfang2),
	ID \== ID2,
	ritter_hof(ID,Farbe,Anzahl1,SpielfeldAnfang2),
	ritter_hof(ID2,Farbe,Anzahl2,SpielfeldAnfang2),
	Anzahl1 > Anzahl2,
	append([mehrheit(Farbe,ID)],SpielfeldAnfang2,Spielfeld).

setze_mehrheit(Farbe,ID,Spielfeld,Spielfeld) :-
	member(mehrheit(Farbe,ID2),Spielfeld),
	ID \== ID2,
	ritter_hof(ID,Farbe,Anzahl1,Spielfeld),
	ritter_hof(ID2,Farbe,Anzahl2,Spielfeld),
	Anzahl1 =< Anzahl2.


ritter_hof(SpielerID,Farbe,Anzahl,Spielfeld) :-
       farbe(Farbe,Ro1,Gr1,Ge1,Bl1,Pi1),
       member(ritter_gesetzt(SpielerID,Ro,Gr,Ge,Bl,Pi),
	      Spielfeld),
       Anzahl is Ro1*Ro+Gr1*Gr+Ge1*Ge+Bl1*Bl+Pi1*Pi.

%PHASE(0) Hilfsfunktion
%
%Kaiser_bew(Schritte,Feld)
%Bewegt den Kaiser um Schritte auf ein Feld
kaiser_bew(0,Feld,Feld,_).
kaiser_bew(Schritte,Feld,Ziel,Spielfeld) :-
	Schritte > 0,
	member(feld(Feld,_,Feld1),Spielfeld),
	Schritte1 is Schritte-1,
	kaiser_bew(Schritte1,Feld1,Ziel,Spielfeld).

%PHASE(-1) Hilfsfunktionen
%feld_punkte(Feld,SpielerID,Punkte)
%gibt die Gesamtpunkte eines Spielers auf einem bestimmten Feld zurück
feld_punkte(Feld,SpielerID,Punkte,Spielfeld) :-
	member(burgen(Feld,SpielerID,Punkte2),Spielfeld),
	feld_ritter(Feld,SpielerID,Punkte1,Spielfeld),
	Punkte is Punkte1 + Punkte2.

feld_punkte(Feld,SpielerID,Punkte,Spielfeld) :-
	feld_ritter(Feld,SpielerID,Punkte,Spielfeld),
	not(member(burgen(Feld,SpielerID,_),Spielfeld)).

%gibt die Ritterpunkte eines Spielers auf einem Feld wieder
feld_ritter(Feld,SpielerID,Punkte,Spielfeld) :-
	member(spieler(_,SpielerID,_),Spielfeld),
	findall(Farbe,
		member(mehrheit(Farbe,SpielerID),Spielfeld),
		MehrListe),
	ritter_punkte(Feld,MehrListe,Punkte,Spielfeld).

ritter_punkte(_,[],0,_).
ritter_punkte(Feld,[Farbe1|Rest],Punkte,Spielfeld) :-
	ritter(Feld,Farbe1,Anzahl,Spielfeld),
	ritter_punkte(Feld,Rest,Anzahl1,Spielfeld),
	Punkte is Anzahl+Anzahl1.

ritter(Feld,Farbe,Anzahl,Spielfeld) :-
	farbe(Farbe,Ro1,Gr1,Ge1,Bl1,Pi1),
	member(ritter_auf_feld(Feld,Ro,Gr,Ge,Bl,Pi),Spielfeld),
	Anzahl is Ro1*Ro+Gr1*Gr+Ge1*Ge+Bl1*Bl+Pi1*Pi.

moeglicher_schritt(Schritt,Gebot) :-
	moegliche_schritte(Schritte,Gebot),
	member(Schritt,Schritte).

moegliche_schritte([1],1).
moegliche_schritte([Gebot|Rest],Gebot):-
	Gebot > 1,
	G2 is Gebot-1,
	moegliche_schritte(Rest,G2).

%fuegt Anzahl burgen zu Spieler hinzu
burgen_zu_spieler(SpielerID,Anzahl,SpielfeldAnfang,Spielfeld) :-
	select(spieler(Name,SpielerID,Aktuell),
	       SpielfeldAnfang,
	       SpielfeldEnde),
        Neu is Anzahl + Aktuell,
	append([spieler(Name,SpielerID,Neu)],
	       SpielfeldEnde,
	       Spielfeld).

mergen(Feld,SpielfeldAnf,Spielfeld) :-
	select(feld(Feld,Vorg,Nachf),SpielfeldAnf,SpielfeldAnfang1),
	(select(burgen(Feld,Besitzer,Anzahl1),SpielfeldAnfang1,SpielfeldAnfang2),
	 select(burgen(Vorg,Besitzer,Anzahl2),SpielfeldAnfang2,SpielfeldAnfang3))
	->
	(Anzahl is Anzahl1+Anzahl2,
	 select(feld(Vorg,VorgN,Feld),SpielfeldAnfang3,SpielfeldAnfang4),
	 select(feld(VorgN,VorgVorg,Vorg),SpielfeldAnfang4,SpielfeldAnfang5),
	 select(ritter_auf_feld(Feld,Ro,Gr,Ge,Bl,Pi),
		SpielfeldAnfang5,
		SpielfeldAnfang6),
	 select(ritter_auf_feld(Vorg,Ro1,Gr1,Ge1,Bl1,Pi1),
		SpielfeldAnfang6,
		SpielfeldAnfang7),
	 Ro2 is Ro+Ro1,
	 Gr2 is Gr+Gr1,
	 Ge2 is Ge+Ge1,
	 Bl2 is Bl+Bl1,
	 Pi2 is Pi+Pi1,
	 append([ritter_auf_feld(Feld,Ro2,Gr2,Ge2,Bl2,Pi2),
	         feld(Feld,VorgN,Nachf),
	         feld(VorgN,VorgVorg,Feld),
	         burgen(Feld,Besitzer,Anzahl)],
	         SpielfeldAnfang7,SpielfeldEnde4),
	 ((select(kaiser(Kaiser),SpielfeldEnde4,SpielfeldEnde5),Kaiser\==Feld)
	->append([kaiser(Feld)],SpielfeldEnde5,Spielfeld);
	  member(kaiser(Kaiser),SpielfeldEnde4),
	  Kaiser==Feld,Spielfeld = SpielfeldEnde4)).
mergen(Feld,Spielfeld,Spielfeld) :-
	member(feld(Feld,Vorg,_),Spielfeld),
	(member(burgen(Feld,Besitzer,_),Spielfeld),
	 member(burgen(Vorg,Besitzer2,_),Spielfeld),
	 Besitzer \== Besitzer2;
	not(member(burgen(Feld,Besitzer,_),Spielfeld));
	not(member(burgen(Vorg,Besitzer,_),Spielfeld))).

%PHASE(-3) Hilfsfunktionen
spieler_wechseln(SpielfeldAnf,Spielfeld) :-
       select(phase(-3),SpielfeldAnf,SpielfeldAnf2),
	% Wenn nur noch ein Spieler in der Liste ist, gibt es keinen nächsten.
	not(member(ziehphase([_]),SpielfeldAnf2)),
	select(ziehphase([_|Neu]),SpielfeldAnf2,SpielfeldAnf3),
	append([ziehphase(Neu), phase(3)],SpielfeldAnf3,Spielfeld).

spielende(SpielfeldAnf,Spielfeld) :-
	(member(spieler(_,Win,Burgen),SpielfeldAnf),Burgen =< 0;
	findall(Feld,member(feld(Feld,_,_),SpielfeldAnf),Liste),
	length(Liste,Anzahl),Anzahl < 4),
	member(spieler(_,Win,Burgen),SpielfeldAnf),
	forall(member(spieler(_,_,Burgen2),SpielfeldAnf),
	       Burgen=<Burgen2),
	findall(Winner,
		member(spieler(_,Winner,Burgen),SpielfeldAnf),
		Gewinner),
	select(phase(_),SpielfeldAnf,SpielfeldEnde),
	append([gewinner(Gewinner)],SpielfeldEnde,Spielfeld).








